About USB-Dataloggerreader
==========================

(c) 2011-2020 by Markus Hoffmann

This app allows to use external USB data loggers together with your tablet 
computer or smartphone.
It implements an interface to temperature, humidity, pressure, sound, 
voltage, current and or CO-gas concentrations USB dataloggers. 
(It is supposed to run only on tablet computers and smartphones, 
which have a USB-(Host)-connection/plug. Android versions >3.1)

It implements following functions:

1. Configuration of the logger,
2. readout of the configuration,
3. Start and Stop of the logging,
4. Readout of the measurement data,
5. Preview the data in a plot,
6. save the data into a file (.csv or ASCII).
7. examine the data in an interactive plot.

Following datalogger devices are supported:

* Voltcraft DL-120-TH, DL-100-T, DL-181-THP
* DL-141-TH (experimental)
* LOG32 
* Lascar EL-USB-1,2,3,4
* USB500 Series
* FreeTec NC7004 (experimental)
* maybe others (not tested). 


### Important Note:

No software can be perfect. We do our best to keep this app bug free, 
improve it and fix all known errors as quick as possible. 
However, this program is distributed in the hope that it will 
be useful, but WITHOUT ANY WARRANTY; without even the implied  
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
Use this program on your own risk. Be aware, that al though unlikely, 
data loss of data stored in the datalogger can occur in case 
of malfunction of the program or under special unforseen usage situations.
Please report all errors, so we can fix them. 

The WRITE EXTERNAL STORAGE permission is needed to write to the file system, 



    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.




Building the .apk file
======================

The build uses the gradle environment. A ./gradlew build should do.

 git clone git@codeberg.org:kollo/USBDataloggerreader-Android.git

then do a 
  cd USBDataloggerreader-Android
  ./gradlew build
(Enter passwords for the keystore)
(the compile process will take a while.)

The apk should finally be in build/outputs/apk/USBDataloggerreader-Android-release.apk

