package com.drhoffmannstoolsdataloggerreader;

/* LoggerPreferencesActivity.java (c) 2011-2020 by Markus Hoffmann
 *
 * This file is part of USB-Dataloggerreader for Android, (c) by Markus Hoffmann 2011-2020
 * ============================================================================
 * USB-Dataloggerreader for Android is free software and comes with 
 * NO WARRANTY - read the file COPYING for details.
 */ 



import android.app.ActionBar;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.AlertDialog.Builder;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.SharedPreferences;
import android.graphics.Color;
import android.os.Bundle;
import android.preference.PreferenceManager;
import android.text.Html;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.LinearLayout;
import android.widget.RadioButton;
import android.widget.RadioGroup;
import android.widget.RelativeLayout;
import android.widget.TextView;

public class LoggerPreferencesActivity  extends Activity {
	private static final String TAG = LoggerPreferencesActivity.class.getSimpleName(); 
	private static CheckBox rawdata,f1,f2,f3,f4,f5,f6,f7,f8,f9,fa,fb,fc,fd,fe,ff,fg,fh,fi,fj,fk;
	private static TextView vid,pid,id,protocol,ltyp,packet,memory,serial,actual,textactual,fversion;
	private static TextView textsensor,sensor,textbattery,battery;
	private static EditText cala,calb,unit,cal1,cal2,cal3,cal4,name,halm,lalm,defunit,defiunit,defcal1,defcal2,defcal3,defcal4;
	private static EditText defhalm,deflalm,defrangedes;
	private static RadioGroup blocktype;
	private static Button repair,recalibrate,emailconfig;
	private static RadioButton b1,b2,b3,b4,b5,b6,b7,b0,b8,b9,b10,b11,b12,b13;
	private static RelativeLayout relcal;
	private static LinearLayout fgroup1,fgroup2,fgroup3,fgroup4,fgroup5;
	private static LoggerConfig config;
	private static Logger logger;

	SharedPreferences prefs;
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);

		setContentView(R.layout.loggerprefs);
		ActionBar actionBar = getActionBar();
		//  actionBar.setHomeButtonEnabled(true);
		actionBar.setDisplayHomeAsUpEnabled(true);
		actionBar.setTitle("Logger Settings");

		vid=(TextView)findViewById(R.id.vid);
		pid=(TextView)findViewById(R.id.pid);
		id=(TextView)findViewById(R.id.id);
		protocol=(TextView)findViewById(R.id.proto);
		ltyp=(TextView)findViewById(R.id.ltyp);
		packet=(TextView)findViewById(R.id.packet);
		memory=(TextView)findViewById(R.id.memory);
		name=(EditText)findViewById(R.id.name);
		serial=(TextView)findViewById(R.id.serial);
		fversion=(TextView)findViewById(R.id.fversion);

		battery=(TextView)findViewById(R.id.battery);
		textbattery=(TextView)findViewById(R.id.textbattery);
		sensor=(TextView)findViewById(R.id.sensor);
		textsensor=(TextView)findViewById(R.id.textsensor);
		actual=(TextView)findViewById(R.id.actual);
		textactual=(TextView)findViewById(R.id.textactual);
		cala=(EditText) findViewById(R.id.cala);
		calb=(EditText) findViewById(R.id.calb);
		repair=(Button)findViewById(R.id.repair);
		recalibrate=(Button)findViewById(R.id.recalibrate);
		emailconfig=(Button)findViewById(R.id.emailconfig);

		unit=(EditText) findViewById(R.id.unit);
		cal1=(EditText) findViewById(R.id.cal1);
		cal2=(EditText) findViewById(R.id.cal2);
		cal3=(EditText) findViewById(R.id.cal3);
		cal4=(EditText) findViewById(R.id.cal4);
		halm=(EditText) findViewById(R.id.halm);
		lalm=(EditText) findViewById(R.id.lalm);
		defrangedes=(EditText) findViewById(R.id.defrangedes);
		defunit=(EditText) findViewById(R.id.defunit);
		defiunit=(EditText) findViewById(R.id.defiunit);
		defcal1=(EditText) findViewById(R.id.defcal1);
		defcal2=(EditText) findViewById(R.id.defcal2);
		defcal3=(EditText) findViewById(R.id.defcal3);
		defcal4=(EditText) findViewById(R.id.defcal4);
		defhalm=(EditText) findViewById(R.id.defhalm);
		deflalm=(EditText) findViewById(R.id.deflalm);

		rawdata=(CheckBox) findViewById(R.id.checkbox_rawdata);
		blocktype=(RadioGroup) findViewById(R.id.blocktype);
		b0=(RadioButton) findViewById(R.id.b0);
		b1=(RadioButton) findViewById(R.id.b1);
		b2=(RadioButton) findViewById(R.id.b2);
		b3=(RadioButton) findViewById(R.id.b3);
		b4=(RadioButton) findViewById(R.id.b4);
		b5=(RadioButton) findViewById(R.id.b5);
		b6=(RadioButton) findViewById(R.id.b6);
		b7=(RadioButton) findViewById(R.id.b7);
		b8=(RadioButton) findViewById(R.id.b8);
		b9=(RadioButton) findViewById(R.id.b9);
		b10=(RadioButton) findViewById(R.id.b10);
		b11=(RadioButton) findViewById(R.id.b11);
		b12=(RadioButton) findViewById(R.id.b12);
		b13=(RadioButton) findViewById(R.id.b13);

		fgroup1=(LinearLayout) findViewById(R.id.fgroup1);
		fgroup2=(LinearLayout) findViewById(R.id.fgroup2);
	    fgroup3=(LinearLayout) findViewById(R.id.fgroup3);
	    fgroup4=(LinearLayout) findViewById(R.id.fgroup4);
		fgroup5=(LinearLayout) findViewById(R.id.fgroup5);
		relcal=(RelativeLayout) findViewById(R.id.relativeLayout1);

		f1=(CheckBox) findViewById(R.id.f1);
		f2=(CheckBox) findViewById(R.id.f2);
		f3=(CheckBox) findViewById(R.id.f3);
		f4=(CheckBox) findViewById(R.id.f4);
		f5=(CheckBox) findViewById(R.id.f5);
		f6=(CheckBox) findViewById(R.id.f6);
		f7=(CheckBox) findViewById(R.id.f7);
		f8=(CheckBox) findViewById(R.id.f8);
		f9=(CheckBox) findViewById(R.id.f9);
		fa=(CheckBox) findViewById(R.id.fa);
		fb=(CheckBox) findViewById(R.id.fb);
		fc=(CheckBox) findViewById(R.id.fc);
		fd=(CheckBox) findViewById(R.id.fd);
		fe=(CheckBox) findViewById(R.id.fe);
		ff=(CheckBox) findViewById(R.id.ff);
		fg=(CheckBox) findViewById(R.id.fg);
		fh=(CheckBox) findViewById(R.id.fh);
		fi=(CheckBox) findViewById(R.id.fi);
		fj=(CheckBox) findViewById(R.id.fj);
		fk=(CheckBox) findViewById(R.id.fk);

		prefs =PreferenceManager.getDefaultSharedPreferences(getBaseContext());
		logger=USBDataloggerreaderActivity.logger;
		config=logger.config;

		emailconfig.setOnClickListener(new OnClickListener() {
			public void onClick(View v) { 
				String recipient="dr.markus.hoffmann@gmx.de";
				String subject="Information about my data logger";
				String message="I like to support the development of this app.\n"+
						"This is all information which could be retrieved from my logger:\n"+
						logger.toString()+config.toString();
				Tools.sendEmail(v.getContext(),recipient, subject, message,null);
			}
		});

	}
	@Override
	protected void onStart(){
		super.onStart();


		vid.setText(""+logger.Vid+" ("+logger.Manufacturer+")");
		pid.setText(""+logger.Pid+" ("+logger.Product+")");


		if(logger.protocol==Logger.PROTO_HID) {
			repair.setVisibility(View.VISIBLE);
			repair.setOnClickListener(new OnClickListener() {
				public void onClick(View v) { showDialog(4);}
			});
			recalibrate.setVisibility(View.GONE);
			cala.setVisibility(View.GONE);
			calb.setVisibility(View.GONE);
			unit.setVisibility(View.VISIBLE);
			cal1.setVisibility(View.GONE);
			cal2.setVisibility(View.GONE);
			cal3.setVisibility(View.GONE);
			cal4.setVisibility(View.GONE);
			halm.setVisibility(View.GONE);
			lalm.setVisibility(View.GONE);
			defrangedes.setVisibility(View.GONE);
			defiunit.setVisibility(View.GONE);
			defunit.setVisibility(View.GONE);
			defcal1.setVisibility(View.GONE);
			defcal2.setVisibility(View.GONE);
			defcal3.setVisibility(View.GONE);
			defcal4.setVisibility(View.GONE);
			defhalm.setVisibility(View.GONE);
			deflalm.setVisibility(View.GONE);
			rawdata.setVisibility(View.VISIBLE);
			blocktype.setVisibility(View.GONE);
			actual.setVisibility(View.VISIBLE);
			serial.setVisibility(View.VISIBLE);
			fversion.setVisibility(View.VISIBLE);
			battery.setVisibility(View.GONE);
			textbattery.setVisibility(View.GONE);
			sensor.setVisibility(View.GONE);
			textsensor.setVisibility(View.GONE);
			fgroup1.setVisibility(View.GONE);
			fgroup2.setVisibility(View.GONE);
			fgroup3.setVisibility(View.GONE);
			fgroup4.setVisibility(View.GONE);
			fgroup5.setVisibility(View.GONE);
			relcal.setVisibility(View.GONE);
			actual.setText(String.format("%08x",config.rawinputreading));
			fversion.setText(config.getversion());
			serial.setText(""+config.serial_number);
			unit.setText((config.temp_is_fahrenheit!=0?"°F/%":"°C/%"));
		} else if(logger.protocol==Logger.PROTO_ELV) {
			cala.setVisibility(View.VISIBLE);
			repair.setVisibility(View.VISIBLE);
			repair.setOnClickListener(new OnClickListener() {
				public void onClick(View v) { showDialog(0);}
			});
			recalibrate.setVisibility(View.VISIBLE);
			recalibrate.setOnClickListener(new OnClickListener() {
				public void onClick(View v) { showDialog(2);}
			});
			unit.setVisibility(View.VISIBLE);
			cala.setText(""+config.calibration_Mvalue);
			calb.setVisibility(View.VISIBLE);
			calb.setText(""+config.calibration_Cvalue);

			if(config.block_type>=4) {  // EL-USB-3,4
				unit.setVisibility(View.VISIBLE);
				cal1.setVisibility(View.VISIBLE);
				cal2.setVisibility(View.VISIBLE);
				cal3.setVisibility(View.VISIBLE);
				cal4.setVisibility(View.VISIBLE);
				halm.setVisibility(View.VISIBLE);
				lalm.setVisibility(View.VISIBLE);

				defrangedes.setVisibility(View.VISIBLE);
				defunit.setVisibility(View.VISIBLE);
				defiunit.setVisibility(View.VISIBLE);
				defcal1.setVisibility(View.VISIBLE);
				defcal2.setVisibility(View.VISIBLE);
				defcal3.setVisibility(View.VISIBLE);
				defcal4.setVisibility(View.VISIBLE);
				defhalm.setVisibility(View.VISIBLE);
				deflalm.setVisibility(View.VISIBLE);

				unit.setText(config.getunit());
				cal1.setText(config.getcal1());
				cal2.setText(config.getcal2());
				cal3.setText(config.getcal3());
				cal4.setText(config.getcal4());
				halm.setText(config.gethalmtxt());
				lalm.setText(config.getlalmtxt());

				defcal1.setText(config.getdefcal1());
				defcal2.setText(config.getdefcal2());
				defcal3.setText(config.getdefcal3());
				defcal4.setText(config.getdefcal4());
				defhalm.setText(config.getdefhalmtxt());
				deflalm.setText(config.getdeflalmtxt());
				defunit.setText(config.getdefunit());
				defiunit.setText(config.getdefiunit());
				defrangedes.setText(config.getdefrange());
				fgroup5.setVisibility(View.VISIBLE);
			} else {
				unit.setVisibility(View.GONE);
				cal1.setVisibility(View.GONE);
				cal2.setVisibility(View.GONE);
				cal3.setVisibility(View.GONE);
				cal4.setVisibility(View.GONE);
				halm.setVisibility(View.GONE);
				lalm.setVisibility(View.GONE);
				defrangedes.setVisibility(View.GONE);
				defiunit.setVisibility(View.GONE);
				defunit.setVisibility(View.GONE);
				defcal1.setVisibility(View.GONE);
				defcal2.setVisibility(View.GONE);
				defcal3.setVisibility(View.GONE);
				defcal4.setVisibility(View.GONE);
				defhalm.setVisibility(View.GONE);
				deflalm.setVisibility(View.GONE);
				fgroup5.setVisibility(View.GONE);
			}
			rawdata.setVisibility(View.VISIBLE);
			blocktype.setVisibility(View.VISIBLE);
			relcal.setVisibility(View.VISIBLE);
			if(logger.loggertype==Logger.LTYP_TH || 
					logger.loggertype==Logger.LTYP_THP) {
				fgroup2.setVisibility(View.VISIBLE);
			} else {
				fgroup2.setVisibility(View.GONE);
			}
			
			b0.setChecked(config.block_type==0);
			b1.setChecked(config.block_type==1);
			b2.setChecked(config.block_type==2);
			b3.setChecked(config.block_type==3);
			b4.setChecked(config.block_type==4);
			b5.setChecked(config.block_type==5);
			b6.setChecked(config.block_type==6);
			b7.setChecked(config.block_type==7);
			b8.setChecked(config.block_type==8);
			b9.setChecked(config.block_type==9);
			b10.setChecked(config.block_type==10);
			b11.setChecked(config.block_type==11);
			b12.setChecked(config.block_type==12);
			b13.setChecked(config.block_type==13);

			f1.setChecked((config.flag_bits&Lascar.HIGH_ALARM_STATE)==Lascar.HIGH_ALARM_STATE);
			f2.setChecked((config.flag_bits&Lascar.LOW_ALARM_STATE)==Lascar.LOW_ALARM_STATE);
			f3.setChecked((config.flag_bits&Lascar.HIGH_ALARM_LATCH)==Lascar.HIGH_ALARM_LATCH);
			f4.setChecked((config.flag_bits&Lascar.LOW_ALARM_LATCH)==Lascar.LOW_ALARM_LATCH);
			f5.setChecked((config.flag_bits&Lascar.CH2_HIGH_ALARM_STATE)==Lascar.CH2_HIGH_ALARM_STATE);
			f6.setChecked((config.flag_bits&Lascar.CH2_LOW_ALARM_STATE)==Lascar.CH2_LOW_ALARM_STATE);
			f7.setChecked((config.flag_bits&Lascar.CH2_HIGH_ALARM_LATCH)==Lascar.CH2_HIGH_ALARM_LATCH);
			f8.setChecked((config.flag_bits&Lascar.CH2_LOW_ALARM_LATCH)==Lascar.CH2_LOW_ALARM_LATCH);
			f9.setChecked((config.flag_bits&Lascar.LOGGING_STATE)==Lascar.LOGGING_STATE);
			fa.setChecked((config.flag_bits&Lascar.UNREAD)==Lascar.UNREAD);
			fb.setChecked((config.flag_bits&Lascar.BATTERY_LOW)==Lascar.BATTERY_LOW);
			fc.setChecked((config.flag_bits&Lascar.BATTERY_FAIL)==Lascar.BATTERY_FAIL);
			fd.setChecked((config.flag_bits&Lascar.SENSOR_FAIL)==Lascar.SENSOR_FAIL);
			fe.setChecked((config.flag_bits&0x2000)==0x2000);
			ff.setChecked((config.flag_bits&0x4000)==0x4000);
			fg.setChecked((config.flag_bits&0x8000)==0x8000);
			fh.setChecked((config.flag_bits2&0x1)>0);
			fi.setChecked((config.flag_bits2&0x2)>0);
			fj.setChecked((config.flag_bits2&0x4)>0);
			fk.setChecked((config.flag_bits2&0x8)>0);

			serial.setVisibility(View.VISIBLE);
			serial.setText(""+config.serial_number);
			actual.setVisibility(View.VISIBLE);
			textactual.setVisibility(View.VISIBLE);
			battery.setVisibility(View.VISIBLE);
			textbattery.setVisibility(View.VISIBLE);
			sensor.setVisibility(View.VISIBLE);
			textsensor.setVisibility(View.VISIBLE);
			fversion.setVisibility(View.VISIBLE);
			fversion.setText(config.getversion());
			actual.setText(""+config.rawinputreading);
			if(logger.isreadconfig) {
				if((config.flag_bits&Lascar.BATTERY_FAIL)==Lascar.BATTERY_FAIL) {
					battery.setText("empty ("+config.battery_alarm+")");
					battery.setTextColor(Color.RED);
				} else if((config.flag_bits&Lascar.BATTERY_LOW)==Lascar.BATTERY_LOW) {
					battery.setText("low ("+config.battery_alarm+")");
					battery.setTextColor(Color.YELLOW);
				} else {
					battery.setText("good ("+config.battery_alarm+")");
					battery.setTextColor(Color.GREEN);
				}
			} else {
				battery.setText("unknown");
				battery.setTextColor(Color.CYAN);
			}
			sensor.setText("unknown");
		} else {
			repair.setVisibility(View.GONE);
			recalibrate.setVisibility(View.GONE);
			cala.setVisibility(View.GONE);
			calb.setVisibility(View.GONE);

			unit.setVisibility(View.GONE);
			cal1.setVisibility(View.GONE);
			cal2.setVisibility(View.GONE);
			cal3.setVisibility(View.GONE);
			cal4.setVisibility(View.GONE);
			halm.setVisibility(View.GONE);
			lalm.setVisibility(View.GONE);
			defrangedes.setVisibility(View.GONE);
			defiunit.setVisibility(View.GONE);
			defunit.setVisibility(View.GONE);
			defcal1.setVisibility(View.GONE);
			defcal2.setVisibility(View.GONE);
			defcal3.setVisibility(View.GONE);
			defcal4.setVisibility(View.GONE);
			defhalm.setVisibility(View.GONE);
			deflalm.setVisibility(View.GONE);

			rawdata.setVisibility(View.GONE);
			blocktype.setVisibility(View.GONE);
			actual.setVisibility(View.GONE);
			serial.setVisibility(View.GONE);
			fversion.setVisibility(View.GONE);
			battery.setVisibility(View.GONE);
			textbattery.setVisibility(View.GONE);
			sensor.setVisibility(View.GONE);
			textsensor.setVisibility(View.GONE);

			textactual.setVisibility(View.GONE);
			fgroup2.setVisibility(View.GONE);
			relcal.setVisibility(View.GONE);
			fgroup5.setVisibility(View.VISIBLE);
		}
		id.setText(logger.Serial_id);
		protocol.setText(""+logger.protocol);
		ltyp.setText(""+logger.loggertype);
		packet.setText(""+logger.packet_size+" Bytes.");
		memory.setText(""+logger.memory_size+" Bytes.");
		name.setText(config.getname());


		// toffset.setText(""+.time_offset);
		//      latency.setText(""+settings.getFloat("pcorr_latenz", (float)7*60)/60);
		//      factor.setText(""+settings.getFloat("pcorr_fakt", (float)0.4));
	}
	@Override
	protected void onStop(){
		super.onStop();
		if(logger.protocol==Logger.PROTO_ELV) {
			// .rawinputreading=rawdata.isChecked()?1:0;
			config.calibration_Mvalue=(float)Double.parseDouble(cala.getText().toString());
			config.calibration_Cvalue=(float)Double.parseDouble(calb.getText().toString());
			config.setcal1(cal1.getText().toString());
			config.setcal2(cal2.getText().toString());
			config.setcal3(cal3.getText().toString());
			config.setcal4(cal4.getText().toString());
			config.setunit(unit.getText().toString());

			// We need an Editor object to make preference changes.
			// All objects are from android.context.Context
			// SharedPreferences settings = PreferenceManager.getDefaultSharedPreferences(getBaseContext());
			// SharedPreferences.Editor editor = settings.edit();
			if(b0.isChecked())  config.block_type=0;
			if(b1.isChecked())  config.block_type=1;
			if(b2.isChecked())  config.block_type=2;
			if(b3.isChecked())  config.block_type=3;
			if(b4.isChecked())  config.block_type=4;
			if(b5.isChecked())  config.block_type=5;
			if(b6.isChecked())  config.block_type=6;
			if(b7.isChecked())  config.block_type=7;
			if(b8.isChecked())  config.block_type=8;
			if(b9.isChecked())  config.block_type=9;
			if(b10.isChecked()) config.block_type=10;
			if(b11.isChecked()) config.block_type=11;
			if(b12.isChecked()) config.block_type=12;
			if(b13.isChecked()) config.block_type=13;


			if(f1.isChecked()) config.flag_bits|=Lascar.HIGH_ALARM_STATE; else config.flag_bits&=~Lascar.HIGH_ALARM_STATE;
			if(f2.isChecked()) config.flag_bits|=Lascar.LOW_ALARM_STATE; else config.flag_bits&=~Lascar.LOW_ALARM_STATE;
			if(f3.isChecked()) config.flag_bits|=Lascar.HIGH_ALARM_LATCH; else config.flag_bits&=~Lascar.HIGH_ALARM_LATCH;
			if(f4.isChecked()) config.flag_bits|=Lascar.LOW_ALARM_LATCH; else config.flag_bits&=~Lascar.LOW_ALARM_LATCH;
			if(f5.isChecked()) config.flag_bits|=Lascar.CH2_HIGH_ALARM_STATE; else config.flag_bits&=~Lascar.CH2_HIGH_ALARM_STATE;
			if(f6.isChecked()) config.flag_bits|=Lascar.CH2_LOW_ALARM_STATE; else config.flag_bits&=~Lascar.CH2_LOW_ALARM_STATE;
			if(f7.isChecked()) config.flag_bits|=Lascar.CH2_HIGH_ALARM_LATCH; else config.flag_bits&=~Lascar.CH2_HIGH_ALARM_LATCH;
			if(f8.isChecked()) config.flag_bits|=Lascar.CH2_LOW_ALARM_LATCH; else config.flag_bits&=~Lascar.CH2_LOW_ALARM_LATCH;

			if(fh.isChecked()) config.flag_bits2|=1; else config.flag_bits2&=~1;
			if(fi.isChecked()) config.flag_bits2|=2; else config.flag_bits2&=~2;

		}


		config.setname(name.getText().toString());

		// editor.putBoolean("pcorr", pcorr1.isChecked());
		// editor.putBoolean("dewpoint", dewpoint1.isChecked());
		// editor.putFloat("pcorr_fakt",(float)Double.parseDouble(factor.getText().toString()));
		// editor.putFloat("pcorr_latenz",(float)Double.parseDouble(latency.getText().toString())*60);
		// Commit the edits!
		// editor.commit();
	}
	@Override
	public boolean onOptionsItemSelected(final MenuItem item) {
		switch (item.getItemId())  {
		case android.R.id.home:
			// This is called when the Home (Up) button is pressed
			// in the Action Bar.
			finish();
			return true;
		default: 
			return super.onOptionsItemSelected(item);
		}
	}

	@Override
	protected Dialog onCreateDialog(final int id) {
		Dialog dialog = null;
		if(id==0 || id==4) {
			AlertDialog.Builder builder = new Builder(this);
			builder.setTitle(getResources().getString(R.string.word_repair));
			if(id==4) builder.setMessage(Html.fromHtml("" +
					"<h1>WARNING</h1>" +
					"You need to understand what you are doing: " +
					"The NC7004 Logger will not stop logging, unless you remove the battery." +
					"The repair-Function will just reset the Stored information about when the " +
					"logger was last setup. Some of the recorded data will be preserved, and can still be read out." +
					"It is just not possible anymore to determine where the recording has started." +
					"It is not recommendet to do so. Do you really want to proceed?"));
			else builder.setMessage(Html.fromHtml(getResources().getString(R.string.message_repairwarning)));
			builder.setPositiveButton(getResources().getString(R.string.word_procceed), new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int which) {
					logger.do_repair=true;
					showDialog(1);
				} }); 
			builder.setNeutralButton(getResources().getString(R.string.word_cancel), new DialogInterface.OnClickListener() {
				public void onClick(DialogInterface dialog, int which) {
					logger.do_repair=false;
				} }); 
			dialog = builder.create();
			dialog.setCanceledOnTouchOutside(false);
		} 
		else if(id==1) dialog = Tools.scrollableDialog(this,"",getResources().getString(R.string.message_repairinfo));
		else if(id==2) dialog = Tools.scrollableDialog(this,"",getResources().getString(R.string.message_recalibrateinfo));
		else if(id==3) dialog = Tools.scrollableDialog(this,"",getResources().getString(R.string.message_recalibrateinfo)); 
		return dialog;
	}
}
